unit Unit4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DBTables, DB, Grids, Outline, Mdexplor, ExtCtrls, Connect,
  StdCtrls;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Table2: TTable;
    DataSource2: TDataSource;
    Connections1: TConnections;
    MDExplorer1: TMDExplorer;
    Table3: TTable;
    DataSource3: TDataSource;
    Connections2: TConnections;
    Table4: TTable;
    DataSource4: TDataSource;
    MDExplorer2: TMDExplorer;
    Table1Company: TStringField;
    Table1CustNo: TFloatField;
    Table3CustNo: TFloatField;
    Table3Company: TStringField;
    Table2OrderNo: TFloatField;
    Table2CustNo: TFloatField;
    Table2PO: TStringField;
    Table2AmountPaid: TCurrencyField;
    Table4OrderNo: TFloatField;
    Table4CustNo: TFloatField;
    Table4PO: TStringField;
    Table4AmountPaid: TCurrencyField;
    Table2EmpNo: TIntegerField;
    Label1: TLabel;
    Label2: TLabel;
    procedure MDExplorer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure MDExplorer1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MDExplorer1DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.MDExplorer1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
if Sender is TMDExplorer then
with Sender as TMDExplorer do
  begin
  if not Dragging then
     begin
     if (Shift=[ssLeft]) then
        begin
        BeginDrag(False);
        end;
     end;
  end;

end;

procedure TForm1.MDExplorer1DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  aSource : TMDExplorer;
  aTarget : TMDExplorer;
  TargIndex : Longint;

begin
if (Source is TMDExplorer) AND (Sender is TMDExplorer) then
  begin
  aSource := Source as TMDExplorer;
  aTarget := Sender as TMDExplorer;
  TargIndex := aTarget.GetItem(X,Y);
  { Accept only if source level is one greater than target level }
  Accept := ( (TargIndex > 0) AND
            (aSource.CurrentLevel - 1 = aTarget.Items[TargIndex].Level) );
  end;
end;

procedure TForm1.MDExplorer1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  aSource : TMDExplorer;
  aTarget : TMDExplorer;
  HoldItem : Longint;
  TargetCust : Integer;

begin
if (Source is TMDExplorer) AND (Sender is TMDExplorer) then
  begin
  aSource := Source as TMDExplorer;
  aTarget := Sender as TMDExplorer;
  Application.ProcessMessages;

  { Save current target tree selection }
  HoldItem := aTarget.SelectedItem;

  { Temporarily move target tree to new selection }
  aTarget.SelectedItem := aTarget.GetItem(X,Y);

  { Get new target cust from target tree master dataset }
  TargetCust := aTarget.DataSource1.DataSet.FieldByName('CustNo').AsInteger;

  { Move target tree back to original selection }
  aTarget.SelectedItem := HoldItem;

  { Change source's custno to targets }
  with aSource.DataSource2.DataSet do
     begin
     Edit;
     FieldByName('CustNo').AsInteger := TargetCust;
     Post;
     end;

  { Reload OTHER tree }
  if aSource = MDExplorer1 then
     begin
     HoldItem := MDExplorer2.SelectedItem;  { Reload moves selection to top }
     MDExplorer2.Reload;
     MDExplorer2.SelectedItem := HoldItem;
     end
  else
     begin
     HoldItem := MDExplorer1.SelectedItem;
     MDExplorer1.Reload;
     MDExplorer1.SelectedItem := HoldItem;
     end;
  end;
end;

end.
